Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_New_Allocator Class Reference

Defines a class that provided a simple implementation of memory allocation. More...

`#include <Malloc_Allocator.h>`

Inheritance diagram for ACE_New_Allocator

[legend]
Collaboration diagram for ACE_New_Allocator:

[legend]
List of all members.

## Public Methods
virtual void* | malloc (size_t nbytes)
| These methods are defined.
virtual void* | calloc (size_t nbytes, char initial_value = '\0')
| Allocate <nbytes>, giving them <initial_value>.
virtual void* | calloc (size_t n_elem, size_t elem_size, char initial_value = '\0')
| Allocate <n_elem> each of size <elem_size>, giving them <initial_value>.
virtual void | free (void *ptr)
| Free <ptr> (must have been allocated by ).
virtual int | remove (void)
| These methods are no-ops.
virtual int | bind (const char *name, void *pointer, int duplicates = 0)
virtual int | trybind (const char *name, void *&pointer)
virtual int | find (const char *name, void *&pointer)
| Locate <name> and pass out parameter via pointer. If found, return 0, Returns -1 if failure occurs.
virtual int | find (const char *name)
| returns 0 if the name is in the mapping. -1, otherwise.
virtual int | unbind (const char *name)
| Unbind (remove) the name from the map. Don't return the pointer to the caller.
virtual int | unbind (const char *name, void *&pointer)
| Break any association of name. Returns the value of pointer in case the caller needs to deallocate memory.
virtual int | sync (ssize_t len = -1, int flags = MS_SYNC)
virtual int | sync (void *addr, size_t len, int flags = MS_SYNC)
| Sync <len> bytes of the memory region to the backing store starting at .
virtual int | protect (ssize_t len = -1, int prot = PROT_RDWR)
virtual int | protect (void *addr, size_t len, int prot = PROT_RDWR)
| Change the protection of the pages of the mapped region to <prot> starting at up to <len> bytes.
virtual void | dump (void) const
| Dump the state of the object.

## Detailed Description

Defines a class that provided a simple implementation of memory allocation.

This class uses the new/delete operators to allocate and free up memory. Please note that the only methods that are supported are <malloc>, <calloc>, and <free>. All other methods are no-ops that return -1 and set <errno> to <ENOTSUP>. If you require this functionality, please use: ACE_Allocator_Adapter >, which will allow you to use the added functionality of bind/find/etc. while using the new/delete operators.

## Member Function Documentation

ACE_INLINE int ACE_New_Allocator::bind ( | const char * name,
| void * pointer,
| int duplicates = 0 )`[virtual]`

| Associate <name> with <pointer>. If <duplicates> == 0 then do not allow duplicate <name>/<pointer> associations, else if <duplicates> != 0 then allow duplicate <name>/<pointer> assocations. Returns 0 if successfully binds (1) a previously unbound <name> or (2) <duplicates> != 0, returns 1 if trying to bind a previously bound <name> and <duplicates> == 0, else returns -1 if a resource failure occurs. Reimplemented from ACE_Allocator.

ACE_INLINE void * ACE_New_Allocator::calloc ( | size_t n_elem,
| size_t elem_size,
| char initial_value = '\0' )`[virtual]`

| Allocate <n_elem> each of size <elem_size>, giving them <initial_value>. Reimplemented from ACE_Allocator. Reimplemented in ACE_Cached_Allocator.

ACE_INLINE void * ACE_New_Allocator::calloc ( | size_t nbytes,
| char initial_value = '\0' )`[virtual]`

| Allocate <nbytes>, giving them <initial_value>. Reimplemented from ACE_Allocator. Reimplemented in ACE_Cached_Allocator.

ACE_INLINE void ACE_New_Allocator::dump ( | void ) const`[virtual]`

| Dump the state of the object. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_New_Allocator::find ( | const char * name )`[virtual]`

| returns 0 if the name is in the mapping. -1, otherwise. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_New_Allocator::find ( | const char * name,
| void *& pointer )`[virtual]`

| Locate <name> and pass out parameter via pointer. If found, return 0, Returns -1 if failure occurs. Reimplemented from ACE_Allocator.

ACE_INLINE void ACE_New_Allocator::free ( | void * ptr )`[virtual]`

| Free <ptr> (must have been allocated by ). Reimplemented from ACE_Allocator. Reimplemented in ACE_Cached_Allocator.

ACE_INLINE void * ACE_New_Allocator::malloc ( | size_t nbytes )`[virtual]`

| These methods are defined. Reimplemented from ACE_Allocator. Reimplemented in ACE_Cached_Allocator.

ACE_INLINE int ACE_New_Allocator::protect ( | void * addr,
| size_t len,
| int prot = PROT_RDWR )`[virtual]`

| Change the protection of the pages of the mapped region to <prot> starting at up to <len> bytes. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_New_Allocator::protect ( | ssize_t len = -1,
| int prot = PROT_RDWR )`[virtual]`

| Change the protection of the pages of the mapped region to <prot> starting at <this->base_addr_> up to <len> bytes. If <len> == -1 then change protection of all pages in the mapped region. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_New_Allocator::remove ( | void )`[virtual]`

| These methods are no-ops. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_New_Allocator::sync ( | void * addr,
| size_t len,
| int flags = MS_SYNC )`[virtual]`

| Sync <len> bytes of the memory region to the backing store starting at . Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_New_Allocator::sync ( | ssize_t len = -1,
| int flags = MS_SYNC )`[virtual]`

| Sync <len> bytes of the memory region to the backing store starting at <this->base_addr_>. If <len> == -1 then sync the whole region. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_New_Allocator::trybind ( | const char * name,
| void *& pointer )`[virtual]`

| Associate <name> with <pointer>. Does not allow duplicate <name>/<pointer> associations. Returns 0 if successfully binds (1) a previously unbound <name>, 1 if trying to bind a previously bound <name>, or returns -1 if a resource failure occurs. When this call returns <pointer>'s value will always reference the void * that <name> is associated with. Thus, if the caller needs to use <pointer> (e.g., to free it) a copy must be maintained by the caller. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_New_Allocator::unbind ( | const char * name,
| void *& pointer )`[virtual]`

| Break any association of name. Returns the value of pointer in case the caller needs to deallocate memory. Reimplemented from ACE_Allocator.

ACE_INLINE int ACE_New_Allocator::unbind ( | const char * name )`[virtual]`

| Unbind (remove) the name from the map. Don't return the pointer to the caller. Reimplemented from ACE_Allocator.

The documentation for this class was generated from the following files:

- Malloc_Allocator.h
- Malloc_Allocator.i